package nodeinfo

import (
	"testing"

	"github.com/stretchr/testify/assert"
)

func TestFetcherDoMatrix(t *testing.T) {
	f := newFetcher("matrix.org")
	info, err := f.do()
	assert.NoError(t, err)
	if assert.NotNil(t, info) {
		assert.EqualValues(t, "Synapse", info.Software.Name)
		assert.EqualValues(t, "https://matrix-org.github.io/synapse/latest/", info.Software.Homepage)
		assert.Truef(t, len(info.Software.Version) != 0, "expect a version")
	}
}

func TestFetcherDoMastodon(t *testing.T) {
	f := newFetcher("chaos.social")
	info, err := f.do()
	assert.NoError(t, err)
	if assert.NotNil(t, info) {
		assert.EqualValues(t, "mastodon", info.Software.Name)
		assert.Truef(t, len(info.Software.Version) != 0, "expect a version")
		assert.EqualValues(t, []string{"activitypub"}, info.Protocols)
	}
}

func TestFetcherDoDiaspora(t *testing.T) {
	f := newFetcher("diasp.org")
	info, err := f.do()
	assert.NoError(t, err)
	if assert.NotNil(t, info) {
		assert.EqualValues(t, "diaspora", info.Software.Name)
		assert.Truef(t, len(info.Software.Version) != 0, "expect a version")
		assert.EqualValues(t, []string{"diaspora"}, info.Protocols)
		assert.NotNil(t, info.Metadata["camo"])
		assert.Nil(t, info.Metadata["random"])
	}
}
